Index: trunk/vizservers/nanovis/nanovis.cpp
===================================================================
--- trunk/vizservers/nanovis/nanovis.cpp	(revision 828)
+++ trunk/vizservers/nanovis/nanovis.cpp	(revision 829)
@@ -1634,93 +277,4 @@
     sprintf(buffer, str, v1, v2, v3);
     write(0, buffer, strlen(buffer));
-}
-
-
-static int 
-PlaneNewCmd _ANSI_ARGS_((ClientData cdata, Tcl_Interp *interp, int argc, CONST84 char *argv[])){
-  fprintf(stderr, "load plane for 2D visualization command\n");
-
-  int index, w, h;
-
-  if (argc != 4) {
-    Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
-		" plane_index w h \"", (char*)NULL);
-    return TCL_ERROR;
-  }
-  if (Tcl_GetInt(interp, argv[1], &index) != TCL_OK) {
-	return TCL_ERROR;
-  }
-  if (Tcl_GetInt(interp, argv[2], &w) != TCL_OK) {
-	return TCL_ERROR;
-  }
-  if (Tcl_GetInt(interp, argv[3], &h) != TCL_OK) {
-	return TCL_ERROR;
-  }
-
-  //Now read w*h*4 bytes. The server expects the plane to be a stream of floats 
-  char* tmp = new char[int(w*h*sizeof(float))];
-  bzero(tmp, w*h*4);
-  int status = read(0, tmp, w*h*sizeof(float));
-  if (status <= 0){
-    exit(0);
-  }
- 
-  plane[index] = new Texture2D(w, h, GL_FLOAT, GL_LINEAR, 1, (float*)tmp);
-  
-  delete[] tmp;
-  return TCL_OK;
-}
-
-
-static 
-int PlaneLinkCmd _ANSI_ARGS_((ClientData cdata, Tcl_Interp *interp, int argc, CONST84 char *argv[])){
-  fprintf(stderr, "link the plane to the 2D renderer command\n");
-
-  int plane_index, tf_index;
-
-  if (argc != 3) {
-    Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
-		" plane_index tf_index \"", (char*)NULL);
-    return TCL_ERROR;
-  }
-  if (Tcl_GetInt(interp, argv[1], &plane_index) != TCL_OK) {
-	return TCL_ERROR;
-  }
-  if (Tcl_GetInt(interp, argv[2], &tf_index) != TCL_OK) {
-	return TCL_ERROR;
-  }
-
-  //plane_render->add_plane(plane[plane_index], tf[tf_index]);
-
-  return TCL_OK;
-}
-
-
-//Enable a 2D plane for render
-//The plane_index is the index mantained in the 2D plane renderer
-static 
-int PlaneEnableCmd _ANSI_ARGS_((ClientData cdata, Tcl_Interp *interp, int argc, CONST84 char *argv[])){
-  fprintf(stderr, "enable a plane so the 2D renderer can render it command\n");
-
-  int plane_index, mode;
-
-  if (argc != 3) {
-    Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
-		" plane_index mode \"", (char*)NULL);
-    return TCL_ERROR;
-  }
-  if (Tcl_GetInt(interp, argv[1], &plane_index) != TCL_OK) {
-	return TCL_ERROR;
-  }
-  if (Tcl_GetInt(interp, argv[2], &mode) != TCL_OK) {
-	return TCL_ERROR;
-  }
-
-  if(mode==0)
-    plane_render->set_active_plane(-1);
-  else
-    plane_render->set_active_plane(plane_index);
-
-  return TCL_OK;
 }
 
@@ -2708,4 +1262,52 @@
 }
 
+
+int renderLegend(int ivol, int width, int height, const char* volArg)
+{
+    TransferFunction *tf = NULL;
+
+    if (ivol < n_volumes) {
+        tf = g_vol_render->get_volume_shading(volume[ivol]);
+    }
+
+    if (tf == NULL) {
+        return TCL_ERROR;
+    }
+
+    int old_width = win_width;
+    int old_height = win_height;
+
+    plane_render->set_screen_size(width, height);
+    resize_offscreen_buffer(width, height);
+
+    // generate data for the legend
+    float data[512];
+    for (int i=0; i < 256; i++) {
+        data[i] = data[i+256] = (float)(i/255.0);
+    }
+    plane[0] = new Texture2D(256, 2, GL_FLOAT, GL_LINEAR, 1, data);
+    int index = plane_render->add_plane(plane[0], tf);
+    plane_render->set_active_plane(index);
+
+    offscreen_buffer_capture();
+    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //clear screen
+    plane_render->render();
+
+    // INSOO
+    glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, screen_buffer);
+    //glReadPixels(0, 0, width, height, GL_BGR, GL_UNSIGNED_BYTE, screen_buffer); // INSOO's
+
+    std::ostringstream result;
+    result << "nv>legend " << volArg;
+    result << " " << volume[ivol]->range_min();
+    result << " " << volume[ivol]->range_max();
+    bmp_write(result.str().c_str());
+    write(0, "\n", 1);
+
+    plane_render->remove_plane(index);
+    resize_offscreen_buffer(old_width, old_height);
+
+    return TCL_OK;
+}
 
 //initialize frame buffer objects for offscreen rendering
@@ -2942,67 +1544,4 @@
 }
 
-
-
-void initTcl()
-{
-    interp = Tcl_CreateInterp();
-    Tcl_MakeSafe(interp);
-
-    Tcl_DStringInit(&cmdbuffer);
-
-    // manipulate the viewpoint
-    Tcl_CreateCommand(interp, "camera", CameraCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    // turn on/off cut planes in x/y/z directions
-    Tcl_CreateCommand(interp, "cutplane", CutplaneCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    // request the legend for a plot (transfer function)
-    Tcl_CreateCommand(interp, "legend", LegendCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    // change the size of the screen (size of picture generated)
-    Tcl_CreateCommand(interp, "screen", ScreenCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    // manipulate transfer functions
-    Tcl_CreateCommand(interp, "transfunc", TransfuncCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    // set the "up" direction for volumes
-    Tcl_CreateCommand(interp, "up", UpCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    // manipulate volume data
-    Tcl_CreateCommand(interp, "volume", VolumeCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    Tcl_CreateCommand(interp, "axis", AxisCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    Tcl_CreateCommand(interp, "grid", GridCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    Tcl_CreateCommand(interp, "heightmap", HeightMapCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-    // get screenshot
-    Tcl_CreateCommand(interp, "screenshot", ScreenShotCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-
-#ifdef __TEST_CODE__
-    Tcl_CreateCommand(interp, "test", TestCmd,
-        (ClientData)NULL, (Tcl_CmdDeleteProc*)NULL);
-#endif
-
-    // create a default transfer function
-    if (Tcl_Eval(interp, def_transfunc) != TCL_OK) {
-        fprintf(stdin, "WARNING: bad default transfer function\n");
-        fprintf(stdin, Tcl_GetStringResult(interp));
-    }
-}
-
-
 void read_screen()
 {
@@ -3207,97 +1746,4 @@
 }
 
-
-void xinetd_listen(){
-
-    int flags = fcntl(0, F_GETFL, 0); 
-    fcntl(0, F_SETFL, flags & ~O_NONBLOCK);
-
-    int status = TCL_OK;
-    int npass = 0;
-
-    //
-    //  Read and execute as many commands as we can from stdin...
-    //
-    while (status == TCL_OK) {
-        //
-        //  Read the next command from the buffer.  First time through
-        //  we block here and wait if necessary until a command comes in.
-        //
-        //  BE CAREFUL:  Read only one command, up to a newline.
-        //  The "volume data follows" command needs to be able to read
-        //  the data immediately following the command, and we shouldn't
-        //  consume it here.
-        //
-        while (1) {
-            char c = getchar();
-            if (c <= 0) {
-                if (npass == 0) {
-                    exit(0);  // EOF -- we're done!
-                } else {
-                    break;
-                }
-            }
-            Tcl_DStringAppend(&cmdbuffer, &c, 1);
-
-            if (c=='\n' && Tcl_CommandComplete(Tcl_DStringValue(&cmdbuffer))) {
-                break;
-            }
-        }
-
-        // no command? then we're done for now
-        if (Tcl_DStringLength(&cmdbuffer) == 0) {
-            break;
-        }
-
-        // back to original flags during command evaluation...
-        fcntl(0, F_SETFL, flags & ~O_NONBLOCK);
-
-        status = Tcl_Eval(interp, Tcl_DStringValue(&cmdbuffer));
-        Tcl_DStringSetLength(&cmdbuffer, 0);
-
-        // non-blocking for next read -- we might not get anything
-        fcntl(0, F_SETFL, flags | O_NONBLOCK);
-        npass++;
-    }
-    fcntl(0, F_SETFL, flags);
-
-    if (status != TCL_OK) {
-        std::ostringstream errmsg;
-        errmsg << "ERROR: " << Tcl_GetStringResult(interp) << std::endl;
-        write(0, errmsg.str().c_str(), errmsg.str().size());
-        return;
-    }
-
-    //
-    //  Generate the latest frame and send it back to the client
-    //
-    // INSOO
-    offscreen_buffer_capture();  //enable offscreen render
-
-    display();
-
-    // INSOO
-#ifdef XINETD
-   read_screen();
-   glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0); 
-#else
-   display_offscreen_buffer(); //display the final rendering on screen
-   read_screen();
-   glutSwapBuffers(); 
-#endif   
-
-#if DO_RLE
-    do_rle();
-    int sizes[2] = {  offsets_size*sizeof(offsets[0]), rle_size }; 
-    fprintf(stderr, "Writing %d,%d\n", sizes[0], sizes[1]); fflush(stderr);
-    write(0, &sizes, sizeof(sizes));
-    write(0, offsets, offsets_size*sizeof(offsets[0]));
-    write(0, rle, rle_size);	//unsigned byte
-#else
-    bmp_write("nv>image -bytes");
-#endif
-}
-
-
 /*
 //draw vectors 
@@ -3337,4 +1783,5 @@
 
 #ifdef XINETD
+    // in Command.cpp
     xinetd_listen();
 #else
Index: trunk/vizservers/nanovis/nanovis.h
===================================================================
--- trunk/vizservers/nanovis/nanovis.h	(revision 828)
+++ trunk/vizservers/nanovis/nanovis.h	(revision 829)
@@ -13,4 +13,6 @@
  * ======================================================================
  */
+#ifndef __NANOVIS_H__
+#define __NANOVIS_H__
 
 #include <GL/glew.h>
@@ -24,4 +26,15 @@
 #include <assert.h>
 #include <float.h>
+#include <getopt.h>
+#include <stdio.h>
+#include <math.h>
+#include <fstream>
+#include <sstream>
+#include <string>
+#include <sys/time.h>
+#include <sys/types.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <signal.h>
 
 #include "define.h"
@@ -87,4 +100,5 @@
 
 
+/*
 //variables for mouse events
 float live_rot_x = 90.;		//object rotation angles
@@ -120,2 +134,5 @@
 //currently active shader, default renders one volume only
 int cur_shader = 0;
+*/
+
+#endif 
